#--*-perl-*-------------------------------------------------------------
#$Author: saulius $
#$Date: 2006-05-12 09:40:28 +0300 (Fri, 12 May 2006) $
#$Revision: 1056 $
#$URL: svn+ssh://saulius-grazulis.lt/home/saulius/svn-repositories/cce/modules/Primes.pm $
#-----------------------------------------------------------------------
#    Split a number into prime factors
#-----------------------------------------------------------------------

package Primes;

use strict;
require Exporter;
@Primes::ISA = qw(Exporter);
@Primes::EXPORT = qw(factorise);

@Primes::primes = (2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,
                   73,79,83,89,97);

sub factorise
{
   my $number = shift;
   my @factors = ();
   my $prime;
   foreach $prime ( @Primes::primes ) {
      while( $number % $prime == 0 ) {
         push(@factors, $prime);
         $number /= $prime;
      }
      last if $number == 1;
   }
   die("Could not factorise $number with first " . 
       "@{[scalar(@Primes::primes)]} prime numbers") 
       if $number != 1;
   return @factors;
}

1;
