package Crunch;

use strict;
use Exporter;
@Crunch::ISA = qw(Exporter);
@Crunch::EXPORT = qw(crunch);

sub crunch
{
    my ($string, $length) = @_;
    $string =~ /(\.[^.]*)?$/;
    $string = $`;
    my @name = split /[^a-zA-Z0-9]/, $string;
    my @new_name = ("") x @name;
    
    if( length($string) <= $length ) { return $string }
    
    my $position = 0;
    APPEND: while($length-- > 0 and @name > 0 ) {
        $new_name[$position] .= substr($name[$position], 0, 1);
        $name[$position] = substr($name[$position], 1);
        if( length($name[$position]) == 0 ) {
            splice(@name, $position, 1);
            $position = 0 if $position >= @name;
        } else {
            $position = ($position + 1) % @name;
        }
    }
    return join("", @new_name)
}
