#--*-perl-*-------------------------------------------------------------
#$Author: saulius $
#$Date: 2006-05-12 09:40:28 +0300 (Fri, 12 May 2006) $
#$Revision: 1056 $
#$URL: svn+ssh://saulius-grazulis.lt/home/saulius/svn-repositories/cce/modules/PermMatrix.pm $
#-----------------------------------------------------------------------
# Reading header information from Mar IPS files
#-----------------------------------------------------------------------

package PermMatrix;

use strict;
require Exporter;
@PermMatrix::ISA = qw(Exporter);
@PermMatrix::EXPORT = qw( permutationMatrix );

sub permutationMatrix
{
    my $permutation = lc(shift);
    my @matrix = ([0,0,0],[0,0,0],[0,0,0]);
    my $pos;

    my $factor = 1;
    my $pos = 0;
    for (split(//, $permutation)) {
        if( /-/ ) { $factor = -1; next }
        $matrix[$pos][0] = $factor if /h/;
        $matrix[$pos][1] = $factor if /k/;
        $matrix[$pos][2] = $factor if /l/;
        die("must have a 'hkl' letter permutation for permutationMatrix\n")
	    if ! /h|k|l/ or $pos > 2;
        $factor = 1;
        $pos ++;
    }

    return @matrix;
}

